

#include <sdktools>
#include <dhooks>
//#include <givedefaultitems>


public Plugin myinfo = 
{
	name = "Block Give Default Items callback",
	author = "Bacardi",
	description = "Block given default weapons hl2mp and cstrike",
	version = "1.0",
	url = "http://www.sourcemod.net/"
};


Handle GiveDefaultItems;
ConVar sm_givedefaultitems_mode;

GlobalForward GiveDefaultItemsPostForward;

public void OnPluginStart()
{
	Handle hGameData = LoadGameConfigFile("dhooks.givedefauitItems");
	if (!hGameData)
	{
		SetFailState("Failed to load dhooks.givedefauitItems.txt gamedata.");
		return;
	}


	GiveDefaultItems = DHookCreateFromConf(hGameData, "GiveDefaultItems");
	if (!GiveDefaultItems)
		SetFailState("Failed to setup detour for GiveDefaultItems");

	delete hGameData;


	if (!DHookEnableDetour(GiveDefaultItems, false, GiveDefaultItems_Pre) ||
		!DHookEnableDetour(GiveDefaultItems, true, GiveDefaultItems_Post))
			SetFailState("Failed to detour GiveDefaultItems_Pre/Post.");

	GiveDefaultItemsPostForward = new GlobalForward("GiveDefaultItemsPost", ET_Ignore, Param_Cell, Param_Cell);

	sm_givedefaultitems_mode = CreateConVar("sm_givedefaultitems_mode", "1", " 0 - disabled\n 1 - no default items when game_player_equip exist\n 2 - no default items", _, true, 0.0, true, 2.0);
}


public APLRes AskPluginLoad2(Handle plugin, bool late, char[] error, int err_max)
{
    RegPluginLibrary("givedefaultitems"); // plugin depedency
    return APLRes_Success;
}







bool FunctionBlocked;

public MRESReturn GiveDefaultItems_Pre(int pThis)
{
	MRESReturn returnvalue = MRES_Ignored;
	FunctionBlocked = false;

	switch(sm_givedefaultitems_mode.IntValue)
	{
		case 1:
		{
			returnvalue = FindEntityByClassname(-1, "game_player_equip") == -1 ? MRES_Ignored:MRES_Supercede;
		}
		case 2:
		{
			returnvalue = MRES_Supercede;
		}
	}

	FunctionBlocked = returnvalue == MRES_Supercede;

	return returnvalue;
}

public MRESReturn GiveDefaultItems_Post(int pThis)
{
	//PrintToServer("GiveDefaultItems_Post");

	/* Start function call */
	Call_StartForward(GiveDefaultItemsPostForward);

	/* Push parameters one at a time */
	Call_PushCell(pThis);
	Call_PushCell(FunctionBlocked);

	/* Finish the call, get the result */
	Call_Finish();

	return MRES_Ignored;
}



